<template>
  <div class="dashboard-request-card-page">
    <div class="mt-3">
      <h2 class="fw-bold">Request Card</h2>
      <div class="my-4">
        <nav>
          <ol class="breadcrumb">
            <li class="breadcrumb-item">
              <a href="#" class="fw-bold text-primary text-decoration-none"
                >Dashboard</a
              >
            </li>
            <li class="breadcrumb-item active" aria-current="page">
              Request Card
            </li>
          </ol>
        </nav>
      </div>

      <div class="mt-3">
        <form @submit.prevent="submitForm">
          <div class="row mt-3">
            <div class="col-sm-12 col-md-4 card-container position-relative">
              <p class="fw-bold">Request Card</p>
              <div class="mt-3">
                <div class="form-group">
                  <label class="mb-2">Account to Debit:</label>
                  <select
                    v-model="form.accountFrom"
                    v-validate="'required'"
                    class="form-select"
                    name="Account to Debit"
                  >
                    <option
                      v-for="(account, i) in userAccounts"
                      :key="i"
                      :value="account"
                    >
                      {{ `${account.AccountType} - ${account.AccountNumber}` }}
                    </option>
                  </select>
                  <div
                    v-show="verrors.has('Account to Debit')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Account to Debit') }}
                  </div>
                </div>
                <div class="form-group">
                  <label class="mb-2">Pick up Branch:</label>
                  <select
                    v-model="form.pickUpBranch"
                    v-validate="'required'"
                    class="form-select"
                    name="Branch"
                  >
                    <option
                      v-for="(branch, i) in branches"
                      :key="i"
                      :value="branch"
                    >
                      {{ `${branch.name}` }}
                    </option>
                  </select>
                  <div v-show="verrors.has('Branch')" class="invalid-feedback">
                    {{ verrors.first('Branch') }}
                  </div>
                </div>
                <div class="form-group mt-3">
                  <label class="mb-2">Transaction PIN</label>

                  <input
                    v-model="form.pin"
                    v-validate="'required'"
                    type="password"
                    class="form-control"
                    name="Transaction PIN"
                  />
                  <div
                    v-show="verrors.has('Transaction PIN')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Transaction PIN') }}
                  </div>
                </div>
                <div class="form-group mt-3">
                  <vs-button :loading="form.active" type="submit" class="px-5">
                    Submit
                  </vs-button>
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-6"></div>
          </div>
        </form>
      </div>

      <!-- Modal -->
      <!-- Successful Modal -->
      <div
        id="SuccessModal"
        class="modal fade"
        tabindex="-1"
        data-bs-backdrop="static"
      >
        <div class="modal-dialog modal-dialog-centered">
          <div
            class="modal-content d-flex justify-content-center align-items-center"
          >
            <div class="modal-body py-5">
              <div class="text-center">
                <img
                  src="@/assets/images/transfer-success-icon.png"
                  alt="Transfer Successfull"
                />
              </div>
              <div class="px-5 text-center mt-3">
                <h3 class="fw-bold text-dark my-2">Successful!</h3>
                <p class="text-muted my-2 px-3">
                  Request Card Successfully updated
                </p>

                <div class="mt-3">
                  <div class="d-flex justify-content-center">
                    <button
                      data-bs-dismiss="modal"
                      type="button"
                      class="btn btn-primary btn-lg rounded-1 px-5 h6"
                      style="font-size: 14px"
                    >
                      <span class="px-2"> OK </span>
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'dashboard',
  middleware: 'users-auth',
  async asyncData({ $axios }) {
    const userAccounts = await $axios.$get('/user/accounts')
    const banks = await $axios.$get('/transaction/banks')
    const branches = await $axios.$get('/miscellaneous/branches')
    // console.log(banks, branches, userAccounts)
    return {
      userAccounts: userAccounts.payload,
      banks: banks.payload.banks,
      branches: branches.payload,
    }
  },
  data: () => ({
    tableHead: [
      'ID',
      'Name of Card',
      'Amount Paid',
      'Date',
      'Status',
      'Action',
    ],
    contentLoading: false,
    page: 1,
    perPage: 10,
    totalPages: 1,
    cards: [],
    form: {
      amount: 0,
      active: false,
    },
    breakingfee: 0,
  }),
  created() {
    this.form.accountFrom = this.userAccounts[0]
    this.form.pickUpBranch = this.branches[0]
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const data = {
            accountNumber: this.form.accountFrom.AccountNumber,
            transactionPin: this.form.pin,
            pickupBranch: this.form.pickUpBranch.name,
          }
          this.form.active = true
          this.$axios
            .$post('/user/request-card', data)
            .then(({ data }) => {
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('SuccessModal'),
                {}
              )
              modal.show()
            })
            .catch((error) => {
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}
.dashboard-request-card-page {
  .active-icon {
    position: relative;
    font-weight: bold;
    // &::before {
    //   content: '';
    //   height: 7px;
    //   width: 7px;
    //   background: #84f014;
    //   position: absolute;
    //   border-radius: 100%;
    //   top: 5px;
    //   left: -10px;
    // }
  }
  .card-container,
  .coreflex-card {
    min-height: 200px;
    // width: 100%;
    background-color: #fff;
    // background-image: url(~@/assets/icons/image-26.svg);
    border-radius: 20px;
    padding: 16px 20px;
    background-repeat: no-repeat;
    background-position: right top;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    margin-bottom: 20px;
  }
  input.form-control,
  .form-select,
  textarea.form-control {
    background-color: #f4f2ec;
    border-radius: 5px;
    border: none;
  }
}
</style>
